Attribute VB_Name = "FeatureFunctions"
Public Function SaveConfig()
    WriteStuff "Main", "Username", varUsername
    WriteStuff "Main", "Password", varPassword
    WriteStuff "Main", "CDKey", varCDKey
    WriteStuff "Main", "LoDCDKey", varLoDCDKey
    WriteStuff "Main", "Server", varServer
    WriteStuff "Main", "Home", varHomeChannel
    
    WriteStuff "Idle", "Use", varUseIdle
    WriteStuff "Idle", "Type", varIdleType
    WriteStuff "Idle", "Message", varIdleMessage
    
    WriteStuff "Other", "LagPlugIcon", varLagPlug
    WriteStuff "Other", "AutoRealm", varAutoRealm
    WriteStuff "Other", "AutoBnet", varAutoBnet
    WriteStuff "Other", "AutoClear", varAutoClear
    WriteStuff "Other", "TalksMessage", var30Talks
    WriteStuff "Other", "FontSize", varFontSize
    WriteStuff "Other", "AccountManager", varAccountManager
    
    WriteStuff "AutoChar", "AutoChar", varAutoRealmChar
    WriteStuff "AutoChar", "Realm", varAutoRealmCharRealm
    WriteStuff "AutoChar", "CharName", varAutoRealmCharName
End Function
Public Function LoadConfig()
    varUsername = GetStuff("Main", "Username")
    varPassword = GetStuff("Main", "Password")
    varCDKey = UCase(GetStuff("Main", "CDKey"))
    varLoDCDKey = UCase(GetStuff("Main", "LoDCDKey"))
    varServer = GetStuff("Main", "Server")
    varHomeChannel = GetStuff("Main", "Home")
    
    varUseIdle = GetStuff("Idle", "Use")
        If varUseIdle = True Then
            frmMain.TimerIdle.Enabled = True
        Else
            frmMain.TimerIdle.Enabled = False
        End If
    varIdleType = GetStuff("Idle", "Type")
    varIdleMessage = GetStuff("Idle", "Message")
    
    varLagPlug = GetStuff("Other", "LagPlugIcon")
    varAutoRealm = GetStuff("Other", "AutoRealm")
    varAutoBnet = GetStuff("Other", "AutoBnet")
    varAutoClear = GetStuff("Other", "AutoClear")
    var30Talks = GetStuff("Other", "TalksMessage")
    varFontSize = GetStuff("Other", "FontSize")
    varAccountManager = GetStuff("Other", "AccountManager")
    
    varAutoRealmChar = GetStuff("AutoChar", "AutoChar")
    varAutoRealmCharRealm = GetStuff("AutoChar", "Realm")
    varAutoRealmCharName = GetStuff("AutoChar", "CharName")
    
    frmMain.Caption = "SoupBot - [not connected] - version " & App.Major & "." & App.Minor & " (build " & App.Revision & ")"
    RunningTime = GetTickCount
    frmMain.rtbChat.Font.Size = varFontSize
    End Function
Public Function ParseBinary(strData As String)
Dim usrFlags&, ping&, usrName$, usrText$
If Len(strData) < 4 Then Exit Function
GetValues strData, ping, usrFlags, usrName, usrText
        Select Case Asc(Mid(strData, 5, 1))
            Case ID_WHISPFROM: Event_RecvWhisper usrName, usrFlags, usrText
            Case ID_TALK: Event_Talk usrName, usrFlags, usrText, ping
            Case ID_EMOTE: Event_Emote usrName, usrFlags, usrText
            Case ID_JOIN:
                If varShowJoinLeave = 1 Then
                    Event_Join usrName, usrFlags, usrText, ping
                Else
                End If
            Case ID_USER: Event_User usrName, usrFlags, usrText, ping, strData
            Case ID_FLAGS: Event_Flags usrName, usrFlags, usrText, ping
            Case ID_ERROR: Event_Error usrText
            Case ID_WHISPTO: Event_SendWhisper usrName, usrFlags, usrText, ping
            Case ID_CHAN: Event_Channel usrText, usrFlags, ping
            Case ID_INFO: Event_Info usrText
            Case ID_LEAVE:
                If varShowJoinLeave = 1 Then
                    Event_Leave usrName, usrFlags
                Else
                End If
            Case Else: Event_Unknown strData
        End Select
End Function
Private Sub Event_RecvWhisper(strUser As String, strFlag As Long, strText As String)
    Dim strUser2() As String
    strUser2() = Split(strUser, "*")

    Dim FiltWord As String
    For i = 0 To UBound(Filters())
        FiltWord = Mid(Filters(i), 1, InStr(1, Filters(i), ":") - 1)
        If InStr(1, text, FiltWord) <> 0 Then
            Exit Sub
        End If
    Next i
    For i = 0 To UBound(Filters()) - 1
        If Matches(strUser2(1), Mid$(Filters(i), 1, InStr(1, Filters(i), ":") - 1)) = True Then
            Exit Sub
        End If
    Next i
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    rtbAdd "<from ", vbWhite
    rtbTimeStamp strUser2(1), vbYellow
    rtbTimeStamp "> ", vbWhite, strText & vbNewLine, RGB(150, 150, 150)
    varReplyTo = strUser2(1)
End Sub
Public Sub Event_Emote(user As String, flags As Long, text As String)
    Dim strUser2() As String
    strUser2() = Split(user, "*")
    
    Dim FiltWord As String
    For i = 0 To UBound(Filters())
        FiltWord = Mid(Filters(i), 1, InStr(1, Filters(i), ":") - 1)
        If InStr(1, text, FiltWord) <> 0 Then
            Exit Sub
        End If
    Next i
    For i = 0 To UBound(Filters()) - 1
        If Matches(strUser2(1), Mid$(Filters(i), 1, InStr(1, Filters(i), ":") - 1)) = True Then
            Exit Sub
        End If
    Next i
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    rtbAdd "*" & strUser2(1) & " " & text & "*" & vbNewLine, vbYellow
End Sub
Private Sub Event_Unknown(strText As String)
    Select Case strText
        Case " "
            Exit Sub
            rtbAdd "[unknown]: " & strText & vbNewLine, vbRed
    End Select
End Sub

Private Sub Event_User(strUser As String, strFlag As Long, strstatstring, ping, fullstatstring)
    Dim sString As String
    ParseStatString strstatstring, sString
    Dim strUser2() As String
    strUser2() = Split(strUser, "*")
    
    If InStr(1, LCase(LastChan), "lod usa") <> 0 Then
        Exit Sub
    End If
    
    If EnhListView_Find(frmMain.lstChannel, strUser2(1), True, False) <> "0" Then
        frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(strUser2(1)).Index).ToolTipText = sString & " [Ping: " & ping & "]"
        rtbAdd "Stats Update: " & strUser2(1) & " is here using " & sString & vbNewLine, vbGrey
        Exit Sub
    ElseIf strFlag = "2" Then
        frmMain.lstChannel.ListItems.Add 1, , strUser2(1), , GetIconCode(strstatstring, strFlag)
        frmMain.lstChannel.ListItems(1).ListSubItems.Add , , GetPingCode(ping)
        frmMain.lstChannel.ListItems(1).ToolTipText = "fl " & strFlag & ", " & ping & "ms"
        frmMain.txtChannelInfo.text = LastChan & " [" & frmMain.lstChannel.ListItems.Count & "]"
        frmMain.lstChannel.ListItems(1).ForeColor = &H808080
        rtbAdd strUser2(1) & " is moderating the channel using " & sString & vbNewLine, vbGrey
        GetPingColor strUser2(1), strFlag, ping
    ElseIf strUser2(1) = varUsername Then
        frmMain.lstChannel.ListItems.Add , , strUser2(1), , GetIconCode(strstatstring, strFlag)
        frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ListSubItems.Add , , GetPingCode(ping)
        frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ToolTipText = "fl " & strFlag & ", " & ping & "ms"
        frmMain.txtChannelInfo.text = LastChan & " [" & frmMain.lstChannel.ListItems.Count & "]"
        frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ForeColor = &H808080
        rtbAdd "You are in the channel using " & sString & vbNewLine, vbGrey
        GetPingColor strUser2(1), strFlag, ping
    Else
        frmMain.lstChannel.ListItems.Add , , strUser2(1), , GetIconCode(strstatstring, strFlag)
        frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ListSubItems.Add , , GetPingCode(ping)
        frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ToolTipText = "fl " & strFlag & ", " & ping & "ms"
        frmMain.txtChannelInfo.text = LastChan & " [" & frmMain.lstChannel.ListItems.Count & "]"
        rtbAdd strUser2(1) & " is in the channel using " & sString & vbNewLine, vbGrey
        GetPingColor strUser2(1), strFlag, ping
    End If
    
End Sub
Private Sub Event_Join(strUser As String, strFlag, strstatstring, ping)
    Dim strCount As String, sString As String
    ParseStatString strstatstring, sString
    frmMain.txtChannelInfo.text = LastChan & " [" & frmMain.lstChannel.ListItems.Count + 1 & "]"
    Dim strUser2() As String
    strUser2() = Split(strUser, "*")
    
    frmMain.lstChannel.ListItems.Add , , strUser2(1), , GetIconCode(strstatstring, strFlag)
    frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ListSubItems.Add , , GetPingCode(ping)
    frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ToolTipText = "fl " & strFlag & ", " & ping & "ms"
    GetPingColor strUser2(1), strFlag, ping
    
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    rtbAdd strUser2(1) & " joined the channel using " & sString & vbNewLine, vbDGreen
End Sub
Private Sub Event_Leave(strUser As String, strFlag)
    Dim strUser2() As String
    strUser2() = Split(strUser, "*")
    
    frmMain.lstChannel.ListItems.Remove frmMain.lstChannel.FindItem(strUser2(1)).Index
    frmMain.txtChannelInfo = LastChan & " [" & frmMain.lstChannel.ListItems.Count & "]"
    
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    rtbAdd strUser2(1) & " left the channel." & vbNewLine, vbDGreen
End Sub
Private Sub Event_Talk(strUser As String, strFlag, strText As String, ping)
    Dim strUser2() As String
    strUser2() = Split(strUser, "*")
    
    Dim FiltWord As String
    For i = 0 To UBound(Filters())
        FiltWord = Mid(Filters(i), 1, InStr(1, Filters(i), ":") - 1)
        If InStr(1, text, FiltWord) <> 0 Then
            Exit Sub
        End If
    Next i
    For i = 0 To UBound(Filters()) - 1
        If Matches(strUser2(1), Mid$(Filters(i), 1, InStr(1, Filters(i), ":") - 1)) = True Then
            Exit Sub
        End If
    Next i
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    rtbAdd "<", vbWhite
    rtbTimeStamp strUser2(1), vbYellow
    rtbTimeStamp "> " & strText & vbNewLine, vbWhite
    If var30Talks = "yes" Then
        CountTalks
    Else
    End If
End Sub
Private Sub Event_Broadcast(strText As String)
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    rtbAdd strText & vbNewLine, vbYellow
End Sub
Private Sub Event_Channel(strText As String, strFlag As Long, ping)
    Dim AddValue(0 To 5) As String
    frmMain.lstChannel.ListItems.Clear
    If (strFlag And CHNFLAG_VOID) = CHNFLAG_VOID Then
        AddValue(0) = "chatless channel"
    ElseIf (strFlag And CHNFLAG_MOD) = CHNFLAG_MOD Then
        AddValue(0) = "moderated channel"
        ChanVar = strText
        LastChan = strText
    ElseIf (strFlag And CHNFLAG_STS) = CHNFLAG_STS Then
        AddValue(0) = "product-specific channel"
        ChanVar = strText
        LastChan = strText
    ElseIf (strFlag And CHNFLAG_PUB) = CHNFLAG_PUB Then
        AddValue(0) = "public channel"
        ChanVar = strText
        LastChan = strText
    ElseIf Not flags Then
        AddValue(0) = "private channel"
        ChanVar = strText
        LastChan = strText
    End If
    rtbAdd "Joining " & AddValue(0) & " " & strText & vbNewLine, vbRed
    frmMain.txtChannelInfo.text = strText & " [" & frmMain.lstChannel.ListItems.Count & "]"
    End Sub
Private Sub Event_Flags(strUser As String, strFlag As Long, statstring As String, ping As Long)
    Dim strUser2() As String
    strUser2() = Split(strUser, "*")
    
    If strFlag = "2" Then
        frmMain.lstChannel.ListItems.Remove frmMain.lstChannel.FindItem(strUser2(1)).Index
        frmMain.lstChannel.ListItems.Add 1, , strUser2(1), , GetIconCode(strstatstring, strFlag)
        frmMain.lstChannel.ListItems(1).ListSubItems.Add , , ping
        frmMain.lstChannel.ListItems(1).ToolTipText = "fl " & strFlag & ", " & ping & "ms"
        GetPingColor strUser2(1), strFlag, ping
    ElseIf strFlag = "32" Then
        frmMain.lstChannel.ListItems.Remove frmMain.lstChannel.FindItem(strUser2(1)).Index
        frmMain.lstChannel.ListItems.Add , , strUser2(1), , GetIconCode(strstatstring, strFlag)
        frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ListSubItems.Add , , GetPingCode(ping)
        frmMain.lstChannel.ListItems(frmMain.lstChannel.ListItems.Count).ToolTipText = "fl " & strFlag & ", " & ping & "ms"
        GetPingColor strUser2(1), strFlag, ping
    End If
End Sub
Private Sub Event_SendWhisper(strUser As String, strFlag, strText As String, ping)
    Dim strUser2() As String
    strUser2() = Split(strUser, "*")
    
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    varReWhisperTo = strUser2(1)
    rtbAdd "<to ", vbWhite
    rtbTimeStamp strUser2(1), vbYellow
    rtbTimeStamp "> ", vbWhite, strText & vbNewLine, RGB(150, 150, 150)
End Sub
Private Sub Event_Info(strText As String)
    If InStr(1, strText, "as being away") Then
    Else
    
    If varAutoClear = "yes" Then
        CheckBuffers
    Else
    End If
    
    rtbAdd strText & vbNewLine, vbYellow
    End If
End Sub
Private Sub Event_Error(strText As String)
    rtbAdd strText & vbNewLine, vbRed
End Sub
Public Sub Send(ByVal strText As String, Socket As Winsock, Optional Extra As Boolean)
If Not frmMain.WSbnet.State = sckConnected Then Exit Sub
     gtc = GetTickCount

    Dim p As New PacketBuffer
    p.InsertNTString strText
    p.SendPacket Socket, &HE

    If Left(strText, 1) = "/" Then
        Exit Sub
    End If
    
    rtbAdd "<" & varUsername & "> " & strText & vbNewLine, vbTeal
End Sub
Public Function DeleteChar(character As String)
With udpb
    .InsertWORD &H0
    .InsertNTString character
    .SendPacket &HA, frmMain.WSmcp
End With
End Function
Public Function CreateChar(Class As String, expansion As String, hardcore As String, Name As String)
With udpb
    .InsertDWORD "&H" & charclass(Class)
    .InsertWORD "&H" & CharMask(expansion, hardcore)
    .InsertNTString Name
    .SendPacket &H2, frmMain.WSmcp
End With
End Function
Public Function charclass(Class As String) As String
    If Class = "Amazon" Then
        charclass = "00"
    ElseIf Class = "Sorceress" Then
        charclass = "01"
    ElseIf Class = "Necromancer" Then
        charclass = "02"
    ElseIf Class = "Paladin" Then
        charclass = "03"
    ElseIf Class = "Barbarian" Then
        charclass = "04"
    ElseIf Class = "Druid" Then
        charclass = "05"
    ElseIf Class = "Assassin" Then
        charclass = "06"
    Else
        charclass = "00"
    End If
End Function
Public Function CharMask(exp As String, hc As String) As String
    If (exp = "1") And (hc = "1") Then
        CharMask = "24"
    ElseIf (exp = "1") And (hc = "0") Then
        CharMask = "20"
    ElseIf (exp = "0") And (hc = "1") Then
        CharMask = "04"
    ElseIf (exp = "0") And (hc = "0") Then
        CharMask = "00"
    Else
        CharMask = "24"
    End If
End Function
Public Function DoAddToSendList(text As String)
    frmMain.txtSendText.AddItem text, 0
    If frmMain.txtSendText.ListCount > 9 Then
        frmMain.txtSendText.Clear
    Else
    End If
End Function
Public Function RequestProfile(user As String)
    Dim packetbuf As New PacketBuffer
    packetbuf.InsertDWORD 1
    packetbuf.InsertDWORD 4
    packetbuf.InsertDWORD GetTickCount()
    packetbuf.InsertNTString user
    packetbuf.InsertNTString "Profile\Sex"
    packetbuf.InsertNTString "Profile\Age"
    packetbuf.InsertNTString "Profile\Location"
    packetbuf.InsertNTString "Profile\Description"
    packetbuf.SendPacket frmMain.WSbnet, &H26
    varProfileChecked = user
End Function
Public Function SetProfile(sex As String, age As String, location As String, Description As String)
    Dim packetbuf As New PacketBuffer

    packetbuf.InsertDWORD 1
    packetbuf.InsertDWORD 4
    packetbuf.InsertBYTE 0
    packetbuf.InsertNTString "profile\sex"
    packetbuf.InsertNTString "profile\age"
    packetbuf.InsertNTString "profile\location"
    packetbuf.InsertNTString "profile\description"
    packetbuf.InsertNTString sex
    packetbuf.InsertNTString age
    packetbuf.InsertNTString location
    packetbuf.InsertNTString Description
    packetbuf.SendPacket frmMain.WSbnet, &H27
End Function

Public Function ClearBuffers()
    frmMain.rtbChat.text = ""
    frmMain.txtSendText.text = ""
    frmMain.txtSendText.Clear
    rtbAdd "Every buffer cleared." & vbNewLine, vbBage
End Function

Public Function CheckBuffers()
    If Len(frmMain.rtbChat.text) >= 10000 Then
        ClearBuffers
    Else
    End If
End Function
Public Function ConnectMCP(realm As String)
    Dim rpass As String
    Dim p As New PacketBuffer
    rpass = String(5 * 4, vbNullChar)
        Call A2(rpass, servers)
        p.InsertDWORD &H1
        p.InsertNonNTString rpass
        p.InsertNTString realm
        p.SendPacket frmMain.WSbnet, &H3E
End Function
Public Function LogonRealmChar(charname As String)
        With udpb
            .InsertNTString charname
            .SendPacket &H7, frmMain.WSmcp
        End With
End Function
Public Sub SendCreateAccount(Username As String, Password As String)
    Dim pBuffer As New PacketBuffer
    Dim Result As Boolean
    Dim AccountHash As String
    AccountHash = String(5 * 4, vbNullChar)
    Result = X(AccountHash, Password)

    If Result = True Then
        pBuffer.InsertNonNTString AccountHash
        pBuffer.InsertNTString Username
        pBuffer.SendPacket frmMain.WSbnet, &H3D
    Else
        rtbAdd "Account create failed: result = false!" & vbNewLine, vbRed
        frmMain.WSbnet.Close
    End If
End Sub
Public Function DnsIP(dns As String)
    dns = LCase(dns)
    If (InStr(1, dns, "a")) Or (InStr(1, dns, "e")) Or (InStr(1, dns, "i")) Or (InStr(1, dns, "o")) Or (InStr(1, dns, "u")) Or (InStr(1, dns, "y")) Then
        rtbAdd "Looking up " & dns & "..." & vbNewLine, vbBage
        rtbAdd "Resolved " & dns & " to " & GetIPFromHostName(dns) & "..." & vbNewLine, vbBage
    Else
        rtbAdd "Looking up " & dns & "..." & vbNewLine, vbBage
        rtbAdd "Resolved " & dns & " to " & GetHostNameFromIP(dns) & "..." & vbNewLine, vbBage
    End If
End Function

