Attribute VB_Name = "RandomFunctions"
Public Function rtbAdd(ByVal txtOne As String, ByVal clrOne As Long, Optional ByVal txtTwo As String, Optional ByVal clrTwo As Long)
    TimeStamp
    With frmMain.rtbChat
        .SelStart = Len(.text)
        .SelLength = 0
        .SelColor = clrOne
        .SelText = txtOne
    End With

    If Len(txtTwo) > 0 Then
       With frmMain.rtbChat
           .SelStart = Len(.text)
           .SelLength = 0
           .SelColor = clrTwo
           .SelText = txtTwo
       End With
    End If
End Function
Public Function rtbAddDescription(ByVal txtOne As String, ByVal clrOne As Long, Optional ByVal txtTwo As String, Optional ByVal clrTwo As Long)
    With frmProfile.txtDescription
        .SelStart = Len(.text)
        .SelLength = 0
        .SelColor = clrOne
        .SelText = txtOne
    End With

    If Len(txtTwo) > 0 Then
       With frmProfile.txtDescription
           .SelStart = Len(.text)
           .SelLength = 0
           .SelColor = clrTwo
           .SelText = txtTwo
       End With
    End If
End Function
Public Function WriteStuff(appname As String, key As String, sString As String, Optional strIni As String) As Boolean
Dim sFile As String
Dim L As Long
WriteStuff = False
On Error GoTo WriteStuff_Error
If strIni = "" Then
    sFile = App.Path & "\libraries\soupbot.ini"
Else
    sFile = App.Path & "\" & strIni
End If
L = WritePrivateProfileString(appname, key, sString, sFile)
WriteStuff = True

WriteStuff_Error:
If Err.Number <> 0 Then
MsgBox Err.Description
End If
End Function
Public Function GetStuff(appname As String, key As String, Optional strIni As String) As String
Dim sFile As String
Dim sDefault As String
Dim lSize As Integer
Dim L As Long
Dim sUser As String
sUser = Space$(128)
lSize = Len(sUser)
If strIni = "" Then
    sFile = App.Path & "\libraries\soupbot.ini"
Else
    sFile = strIni
End If
sDefault = ""
L = GetPrivateProfileString(appname, key, sDefault, sUser, lSize, sFile)
sUser = Mid(sUser, 1, InStr(sUser, Chr(0)) - 1)
GetStuff = sUser
End Function
Public Function CVL(X As String) As Long
    If Len(X) < 4 Then
        MsgBox "CVL(): String too short"
        Exit Function 'Stop
    End If
    CopyMemory CVL, ByVal X, 4
End Function

Public Function CVI(X As String) As Integer
    If Len(X) < 2 Then
        MsgBox "CVI(): String too short"
        Stop
    End If
    
    CopyMemory CVI, ByVal X, 2
End Function
Public Function StrToHex(ByVal String1 As String) As String
    Dim strTemp As String, strReturn As String, i As Long
    
    For i = 1 To Len(String1)
        strTemp = Hex(Asc(Mid(String1, i, 1)))
    If Len(strTemp) = 1 Then strTemp = "0" & strTemp
    
    strReturn = strReturn & " " & strTemp
    
    Next i
        StrToHex = strReturn
    
End Function
Public Sub NullTruncString(ByRef text As String)
    Dim i As Integer
    
    i = InStr(text, Chr(0))
    If i = 0 Then Exit Sub
    
    text = Left(text, i - 1)
End Sub
Public Sub DecodeCDKey(ByVal sCDKey As String, ByRef dProductId As Double, ByRef dValue1 As Double, ByRef dValue2 As Double, Optional dxp As Boolean)

    sCDKey = Replace(sCDKey, "-", "")
    sCDKey = Replace(sCDKey, " ", "")

    
    If Len(sCDKey) = 13 Then
        rtbAdd "Detected a Starcraft CDKey, Starcraft not supported." & vbNewLine, vbRed
        Exit Sub
    ElseIf Len(sCDKey) = 16 Then
        sCDKey = DecodeD2Key(sCDKey)
    Else
        Exit Sub
    End If
    
    dProductId = Val("&H" & Left$(sCDKey, 2))
    If dxp = True Then
    dProductId = 10
    End If
    
    If Len(sCDKey) = 13 Then
        dValue1 = Val(Mid$(sCDKey, 3, 7))
        dValue2 = Val(Mid$(sCDKey, 10, 3))

    ElseIf Len(sCDKey) = 16 Then
        dValue1 = Val("&H" & Mid$(sCDKey, 3, 6))
        dValue2 = Val("&H" & Mid$(sCDKey, 9))
    End If
    
End Sub
Public Function KillNull(ByVal text As String) As String
    Dim i As Integer
    i = InStr(1, text, Chr(0))
    If i = 0 Then
        KillNull = text
        Exit Function
    End If
    KillNull = Left(text, i - 1)
End Function
Public Function DecodeD2Key(ByVal key As String) As String
    Dim r As Double, n As Double, n2 As Double, v As Double, _
    v2 As Double, keyvalue As Double, c1 As Byte, c2 As Byte, _
    C As Byte, bValid As Boolean, i As Integer, aryKey(0 To 15) As String, _
    codevalues As String
    
    codevalues = "246789BCDEFGHJKMNPRTVWXZ"
    r = 1
    keyvalue = 0
    
    For i = 1 To 16
    
        aryKey(i - 1) = Mid$(key, i, 1)
        
    Next i
    
    For i = 0 To 15 Step 2
        c1 = InStr(1, codevalues, aryKey(i)) - 1
        If c1 = -1 Then c1 = &HFF
        n = c1 * 3
        c2 = InStr(1, codevalues, aryKey(i + 1)) - 1
        If c2 = -1 Then c2 = &HFF
        n = c2 + n * 8
        
        If n >= &H100 Then
        
            n = n - &H100
            keyvalue = keyvalue Or r
            
        End If
        
        n2 = n
        n2 = RShift(n2, 4)
        aryKey(i) = GetHexValue(n2)
        aryKey(i + 1) = GetHexValue(n)
        r = LShift(r, 1)
        
Cont:

    Next i
    
    v = 3
    
    For i = 0 To 15
    
        C = GetNumValue(aryKey(i))
        n = Val(C)
        n2 = v * 2
        n = n Xor n2
        v = v + n
        
    Next i
    
    v = v And &HFF
    
    For i = 15 To 0 Step -1
    
        C = Asc(aryKey(i))
        
        If i > 8 Then
        
            n = i - 9
            
        Else
        
            n = &HF - (8 - i)
            
        End If
        
        n = n And &HF
        c2 = Asc(aryKey(n))
        aryKey(i) = Chr$(c2)
        aryKey(n) = Chr$(C)
        
    Next i
    
    v2 = &H13AC9741
    
    For i = 15 To 0 Step -1
    
        C = Asc(UCase(aryKey(i)))
        aryKey(i) = Chr$(C)
        
        If Val(C) <= Asc("7") Then
        
            v = v2
            c2 = v And &HF
            c2 = c2 And 7
            c2 = c2 Xor C
            v = RShift(v, 3)
            aryKey(i) = Chr$(c2)
            v2 = v
            
        ElseIf Val(C) < Asc("A") Then
        
            c2 = CByte(i)
            c2 = c2 And 1
            c2 = c2 Xor C
            aryKey(i) = Chr$(c2)
            
        End If
        
    Next i
    
    DecodeD2Key = Join(aryKey, "")
    
    Erase aryKey()
    
End Function
Public Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
' Equivilant to C's Bitwise >> ope
' rator
    RShift = CDbl(pnValue \ (2 ^ pnShift))
End Function
Public Function GetHexValue(ByVal v As Long) As String

    v = v And &HF
    
    If v < 10 Then
    
        GetHexValue = Chr$(v + &H30)
        
    Else
    
        GetHexValue = Chr$(v + &H37)
        
    End If
    
End Function
Public Function LShift(ByVal pnValue As Long, ByVal pnShift As Long) As Double
' Equivilant to C's Bitwise << ope
' rator
    LShift = CDbl(pnValue * (2 ^ pnShift))
End Function
Public Function GetNumValue(ByVal C As String) As Long

    C = UCase(C)
    
    If IsNumeric(C) Then
    
        GetNumValue = Asc(C) - &H30
        
    Else
    
        GetNumValue = Asc(C) - &H37
        
    End If
    
End Function
Public Function GetDWORD(Data As String) As Long
Dim lReturn As Long
    Call CopyMemory(lReturn, ByVal Data, 4)
    GetDWORD = lReturn
End Function
Public Sub ParseStatString(ByVal statstring As String, ByRef outbuf As String)
    Dim Values() As String
    Dim cType As String
    
    Select Case Left$(statstring, 4)
        Case "RHSS"
            Call strcpy(outbuf, "Starcraft Shareware.")
        Case "RATS"
            Values() = Split(Mid$(statstring, 6), " ")
            If UBound(Values) <> 8 Then
                Call sprintf(outbuf, "a Starcraft %sbot.", IIf((Values(3) = 1), " (spawn) ", ""))
                Exit Sub
            End If
            If Values(0) > 0 Then
                Call sprintf(outbuf, "Starcraft%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2), Values(0))
                GameWins = Values(2)
            Else
                Call sprintf(outbuf, "Starcraft%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2))
                GameWins = Values(2)
            End If
        Case "PXES"
            Values() = Split(Mid(statstring, 6), " ")
            If UBound(Values) <> 8 Then
                Call sprintf(outbuf, "a Starcraft Brood War %sbot.", IIf((Values(3) = 1), " (spawn) ", ""))
                Exit Sub
            End If
            If Values(0) > 0 Then
                Call sprintf(outbuf, "Starcraft: Brood War%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2), Values(0))
                GameWins = Values(2)
            Else
                Call sprintf(outbuf, "Starcraft: Brood War%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2))
                GameWins = Values(2)
            End If
        Case "RTSJ"
            Values() = Split(Mid(statstring, 6), " ")
            If UBound(Values) <> 8 Then
                Call sprintf(outbuf, "a Starcraft Japanese %sbot.", IIf((Values(3) = 1), " (spawn) ", ""))
                Exit Sub
            End If
            If Values(0) > 0 Then
                Call sprintf(outbuf, "Japan Starcraft%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2), Values(0))
            Else
                Call sprintf(outbuf, "Japan Starcraft%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2))
            End If
        Case "NB2W"
            Values() = Split(Mid$(statstring, 6), " ")
            If UBound(Values) <> 8 Then
                Call sprintf(outbuf, "a Warcraft II %sbot.", IIf((Values(3) = 1), " (spawn) ", ""))
                Exit Sub
            End If
            If Values(0) > 0 Then
                Call sprintf(outbuf, "Warcraft II: Battle.net Edition%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2), Values(0))
            Else
                Call sprintf(outbuf, "Warcraft II: Battle.net Edition%s (%s wins).", IIf((Values(3) = 1), " (spawn) ", ""), Values(2))
            End If
        Case "RHSD"
            Values() = Split(Mid$(statstring, 6), " ")
            If UBound(Values) <> 8 Then
                Values() = Split(Mid$(statstring, 1), " ", 1)
                Call strcpy(outbuf, "a Diablo Shareware Bot. [Statstring=" & Values(0) & "]")
                Exit Sub
            End If
            Select Case Values(2)
                Case 0: cType = "warrior"
                Case 1: cType = "rogue"
                Case 2: cType = "sorceror"
            End Select
            Call sprintf(outbuf, "Diablo shareware: Level %s %s with %s dots, %s strength, %s magic, %s dexterity, %s vitality, and %s gold.", Values(0), cType, Values(1), Values(3), Values(4), Values(5), Values(6), Values(7))
        Case "LTRD"
            Values() = Split(Mid$(statstring, 6), " ")
            If UBound(Values) <> 8 Then
                Values() = Split(Mid$(statstring, 1), " ", 1)
                Call strcpy(outbuf, "a Diablo Bot. [Statstring=" & Values(0) & "]")
                Exit Sub
            End If
            Select Case Values(2)
                Case 0: cType = "warrior"
                Case 1: cType = "rogue"
                Case 2: cType = "sorceror"
            End Select
            Call sprintf(outbuf, "Diablo (Level %s %s with %s dots, %s strength, %s magic, %s dexterity, %s vitality, and %s gold)", Values(0), cType, Values(1), Values(3), Values(4), Values(5), Values(6), Values(7))
        Case "PX2D"
            Call strcpy(outbuf, ParseD2Stats(statstring))
        Case "VD2D"
            Call strcpy(outbuf, ParseD2Stats(statstring))
        Case "TAHC"
            Call strcpy(outbuf, "a Chat bot.")
        'Case "3RAW"
           ' Call strcpy(outbuf, "WarCraft III: Reign of Chaos.")
        Case "3RAW"
            Call strcpy(outbuf, ParseWC3Stats(statstring))
    End Select
End Sub
Public Function makeserver(Data As String) As String
    makeserver = CLng("&H" & ToHex(Mid(Data, 1, 1))) & "." & CLng("&H" & ToHex(Mid(Data, 2, 1))) & "." & CLng("&H" & ToHex(Mid(Data, 3, 1))) & "." & CLng("&H" & ToHex(Mid(Data, 4, 1)))
End Function
Public Function ToHex(Data As String) As String
Dim i As Integer
For i = 1 To Len(Data)
    ToHex = ToHex & Right("00" & Hex(Asc(Mid(Data, i, 1))), 2)
Next i
End Function
Public Function sprintf(ByRef Source As String, ByVal nText As String, _
    Optional ByVal a As Variant, _
    Optional ByVal b As Variant, _
    Optional ByVal C As Variant, _
    Optional ByVal d As Variant, _
    Optional ByVal e As Variant, _
    Optional ByVal f As Variant, _
    Optional ByVal G As Variant, _
    Optional ByVal H As Variant)
    
    nText = Replace(nText, "%S", "%s")
    Dim i As Byte
    i = 0
    Do While (InStr(1, nText, "%s") <> 0)
        Select Case i
            Case 0
                If IsEmpty(a) Then GoTo TheEnd
                nText = Replace(nText, "%s", a, 1, 1)
            Case 1
                If IsEmpty(b) Then GoTo TheEnd
                nText = Replace(nText, "%s", b, 1, 1)
            Case 2
                If IsEmpty(C) Then GoTo TheEnd
                nText = Replace(nText, "%s", C, 1, 1)
            Case 3
                If IsEmpty(d) Then GoTo TheEnd
                nText = Replace(nText, "%s", d, 1, 1)
            Case 4
                If IsEmpty(e) Then GoTo TheEnd
                nText = Replace(nText, "%s", e, 1, 1)
            Case 5
                If IsEmpty(f) Then GoTo TheEnd
                nText = Replace(nText, "%s", f, 1, 1)
            Case 6
                If IsEmpty(G) Then GoTo TheEnd
                nText = Replace(nText, "%s", G, 1, 1)
            Case 7
                If IsEmpty(H) Then GoTo TheEnd
                nText = Replace(nText, "%s", H, 1, 1)
        End Select
        i = i + 1
    Loop
TheEnd:
    Source = Source & nText
End Function
Public Sub strcpy(ByRef Source As String, ByVal nText As String)
    Source = Source & nText
End Sub
Public Function ParseD2Stats(ByVal stats As String)
    Dim d2classes(0 To 7) As String
        d2classes(0) = "amazon"
        d2classes(1) = "sorceress"
        d2classes(2) = "necromancer"
        d2classes(3) = "paladin"
        d2classes(4) = "barbarian"
        d2classes(5) = "druid"
        d2classes(6) = "assassin"
        d2classes(7) = "unknown class"
    Dim statbuf As String, p() As String, Server As String, Name As String
    If Len(stats) > 4 Then
        Dim sLen As Byte
        sLen = GetServer(stats, Server)
        sLen = GetCharacterName(stats, sLen, Name)
        Call MakeArray(Mid$(stats, sLen), p())
    End If
    If Left$(stats, 4) = "VD2D" Then
        Call strcpy(statbuf, "Diablo II (")
    Else
        Call strcpy(statbuf, "Diablo II: Lord of Destruction (")
    End If
    If (Len(stats) = 4) Then
        Call strcpy(statbuf, "Open character).")
    Else
        Dim Version As Byte
        Version = Asc(p(0)) - &H80
        Dim charclass As Byte
        charclass = Asc(p(13)) - 1
        If (charclass < 0) Or (charclass > 6) Then
            charclass = 7
        End If
        Dim female As Boolean
        female = False
        If (charclass = 0) Or (charclass = 1) Or (charclass = 6) Then
            female = True
        End If
        Dim charlevel As Byte
        charlevel = Asc(p(25))
        Dim hardcore As Byte
        hardcore = Asc(p(26)) And 4
        Dim expansion As Boolean
        expansion = False
        If Left$(stats, 4) = "PX2D" Then
            If (Asc(p(26)) And &H20) Then
                Select Case RShift((Asc(p(27)) And &H18), 3)
                    Case 1
                        If hardcore Then
                            Call strcpy(statbuf, "Destroyer ")
                        Else
                            Call strcpy(statbuf, "Slayer ")
                        End If
                    Case 2
                        If hardcore Then
                            Call strcpy(statbuf, "Conquerer ")
                        Else
                            Call strcpy(statbuf, "Champion ")
                        End If
                    Case 3
                        If hardcore Then
                            Call strcpy(statbuf, "Guardian ")
                        Else
                            If Not female Then
                                Call strcpy(statbuf, "Patriarch ")
                            Else
                                Call strcpy(statbuf, "Matriarch ")
                            End If
                        End If
                End Select
                expansion = True
            End If
        End If
        If Not expansion Then
            Select Case RShift((Asc(p(27)) And &H18), 3)
                Case 1
                    If female = False Then
                        If hardcore Then
                            Call strcpy(statbuf, "Count ")
                        Else
                            Call strcpy(statbuf, "Sir ")
                        End If
                    Else
                        If hardcore Then
                            Call strcpy(statbuf, "Countess ")
                        Else
                            Call strcpy(statbuf, "Dame ")
                        End If
                    End If
                Case 2
                    If female = False Then
                        If hardcore Then
                            Call strcpy(statbuf, "Duke ")
                        Else
                            Call strcpy(statbuf, "Lord ")
                        End If
                    Else
                        If hardcore Then
                            Call strcpy(statbuf, "Duchess ")
                        Else
                            Call strcpy(statbuf, "Lady ")
                        End If
                    End If
                Case 3
                    If female = False Then
                        If hardcore Then
                            Call strcpy(statbuf, "King ")
                        Else
                            Call strcpy(statbuf, "Baron ")
                        End If
                    Else
                        If hardcore Then
                            Call strcpy(statbuf, "Queen ")
                        Else
                            Call strcpy(statbuf, "Baroness ")
                        End If
                    End If
            End Select
        End If
        Call sprintf(statbuf, "%s, a ", Name)
        If hardcore Then
            If (Asc(p(26)) And &H8) Then
                Call strcpy(statbuf, "dead ")
            End If
            Call sprintf(statbuf, "hardcore level %s ", charlevel)
        Else
            Call sprintf(statbuf, "level %s ", charlevel)
        End If
        Call sprintf(statbuf, "%s on realm %s).", d2classes(charclass), Server)
    End If
    ParseD2Stats = statbuf
End Function
Public Function ParseWC3Stats(ByVal stats As String)
    Dim wc3classes(0 To 5) As String
        wc3classes(0) = "humans"
        wc3classes(1) = "orcs"
        wc3classes(2) = "undead"
        wc3classes(3) = "night elves"
        wc3classes(4) = "random"
        wc3classes(5) = "unknown"

    ParseWC3Stats = "WarCraft III: Reign of Chaos."
End Function

Private Function GetServer(ByVal statstring As String, ByRef Server As String) As Byte
    'returns the begining of the character name
    Server = Mid$(statstring, 5, InStr(5, statstring, ",") - 5)
    GetServer = InStr(5, statstring, ",") + 1
End Function

Private Function GetCharacterName(ByVal statstring As String, ByVal start As Byte, ByRef cName As String) As Byte
    cName = Mid$(statstring, start, InStr(start, statstring, ",") - start)
    GetCharacterName = InStr(start, statstring, ",") + 1
End Function
Public Function MakeArray(ByVal text As String, ByRef nArray() As String)
    Dim i As Long
    ReDim nArray(0)
    For i = 0 To Len(text)
        nArray(i) = Mid$(text, i + 1, 1)
        If i <> Len(text) Then
            ReDim Preserve nArray(0 To UBound(nArray) + 1)
        End If
    Next i
End Function
Public Sub GetValues(ByVal DataBuf As String, ByRef ping As Long, ByRef flags As Long, ByRef Name As String, ByRef txt As String)
    Dim a As Long, b As Long, C As Long, d As Long, e As Long, f As Long, recvbufpos As Long
    Name = ""
    txt = ""
    recvbufpos = 5
    f = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    a = CVL(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    b = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    C = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    d = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    e = MakeLong(Mid$(DataBuf, recvbufpos, 4))
    recvbufpos = recvbufpos + 4
    flags = a
    ping = b
    Call strcpy(Name, KillNull(Mid$(DataBuf, 29)))
    Call strcpy(txt, KillNull(Mid$(DataBuf, Len(Name) + 30)))
End Sub
Public Function GetIconCode(ByVal statstring As String, ByVal flags As Long) As Integer
    Dim stProduct As String
    Dim Values() As String
    
    Values() = Split(Mid(statstring, 5, Len(statstring)))
    
    stProduct = Mid$(statstring, 1, 4)

    If (BNFLAGS_BLIZZ And flags) = BNFLAGS_BLIZZ Then
        GetIconCode = 1
        Exit Function
    ElseIf (BNFLAGS_OP And flags) = BNFLAGS_OP Then
        GetIconCode = 6
        Exit Function
    ElseIf (BNFLAGS_SYSOP And flags) = BNFLAGS_SYSOP Then
        GetIconCode = 1
        Exit Function
    ElseIf (BNFLAGS_SQUELCH And flags) = BNFLAGS_SQUELCH Then
        GetIconCode = 10
        Exit Function
    ElseIf (BNFLAGS_GLASSES And flags) = BNFLAGS_GLASSES Then
        GetIconCode = 9
        Exit Function
    ElseIf (BNFLAGS_GFPLAYER And flags) = BNFLAGS_GFPLAYER Then
        GetIconCode = 22
        Exit Function
    ElseIf Not flags Then: GoTo Product
    
    End If
    
Product:

    Select Case stProduct
        Case "PXES": GetIconCode = 11
        Case "RATS": GetIconCode = 8
        Case "RTSJ": GetIconCode = 7
        Case "RHSS": GetIconCode = 12
        Case "NB2W": GetIconCode = 13
        Case "VD2D": GetIconCode = 4
        Case "PX2D": GetIconCode = 3
        Case "LTRD": GetIconCode = 5
        Case "RHSD": GetIconCode = 5
        Case "TAHC": GetIconCode = 2
        Case "3RAW": GetIconCode = 14
        Case Else: GetIconCode = 1
    End Select

End Function
Public Function GetPingCode(ByVal ping As Long) As String
    Select Case ping
        Case Is < 0
            GetPingCode = "lllll"
        Case 0 To 200
            GetPingCode = "l"
        Case 200 To 300
            GetPingCode = "ll"
        Case 300 To 400
            GetPingCode = "lll"
        Case 400 To 500
            GetPingCode = "llll"
        Case 500 To 600
            GetPingCode = "lllll"
        Case Else
            GetPingCode = "llllll"
    End Select
End Function
Public Function GetPingColor(user As String, flags, ping)
If (flags And BNFLAGS_PLUG) = BNFLAGS_PLUG Then
    frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).text = "plug"
    frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbBlue
    Exit Function
Else
End If

    Select Case ping
        Case Is < 0
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbRed
        Case 0 To 200
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbGreen
        Case 200 To 300
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbGreen
        Case 300 To 400
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbYellow
        Case 400 To 500
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbYellow
        Case 500 To 600
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbRed
        Case Else
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).ForeColor = vbRed
    End Select
            frmMain.lstChannel.ListItems(frmMain.lstChannel.FindItem(user).Index).ListSubItems.Item(1).Bold = True
End Function
Public Function MakeLong(X As String) As Long
    If Len(X) < 4 Then Exit Function
    CopyMemory MakeLong, ByVal X, 4
End Function
Public Function MakeInt(X As String) As Integer
    If Len(X) < 2 Then Exit Function
    CopyMemory MakeInt, ByVal X, 2
End Function
Public Function MKI(X As String) As Integer
    If Len(X) < 2 Then Exit Function
    CopyMemory MKI, ByVal X, 2
End Function
Public Function MKL(X As String) As Long
    If Len(X) < 4 Then Exit Function
    CopyMemory MKL, ByVal X, 4
End Function
Public Function TimeStamp()
    rtbTimeStamp "[" & Format(Time, "hh:mm:ss") & "] ", vbWhite
End Function
Public Sub rtbTimeStamp(ByVal txtOne As String, ByVal clrOne As Long, Optional ByVal txtTwo As String, Optional ByVal clrTwo As Long)
    With frmMain.rtbChat
        .SelStart = Len(.text)
        .SelLength = 0
        .SelColor = clrOne
        .SelText = txtOne
    End With

    If Len(txtTwo) > 0 Then
       With frmMain.rtbChat
           .SelStart = Len(.text)
           .SelLength = 0
           .SelColor = clrTwo
           .SelText = txtTwo
       End With
    End If
End Sub
Public Function HexToStr(ByVal Hex1 As String) As String
    Dim strTemp As String, strReturn As String, i As Long
    Hex1 = Replace(Hex1, " ", "")
    If Len(Hex1) Mod 2 <> 0 Then Exit Function

    For i = 1 To Len(Hex1) Step 2
    strReturn = strReturn & Chr(Val("&H" & Mid(Hex1, i, 2)))
    Next i
    HexToStr = strReturn
End Function
Public Function EnhListView_Find(lstListName As ListView, _
                                strStringToFind As String, _
                                Optional bolWholeWordOnly As Boolean, _
                                Optional bolCaseSensitive As Boolean) _
                                As Integer
    Dim lngIndex As Long        ' used for the current index of the parent items
    Dim lngIndexSub As Long     ' used for the current index of the subitems
    Dim strCurrItem As String   ' used to store the text of the currently selected item for compare
    
    If bolCaseSensitive = True Then strStringToFind = UCase(strStringToFind)
        EnhListView_Find = 0
    If lstListName.ListItems.Count < 1 Then Exit Function
    If lstListName.SelectedItem.Index = -1 Then lstListName.SelectedItem.Index = 1
        For lngIndex = lstListName.SelectedItem.Index - -1 To lstListName.ListItems.Count
            If bolCaseSensitive = True Then
                strCurrItem = UCase(lstListName.ListItems.Item(lngIndex).text)
            Else
                strCurrItem = lstListName.ListItems.Item(lngIndex).text
            End If
        
            If bolWholeWordOnly = True Then
                If strCurrItem = strStringToFind Then GoTo Finalize
                Else
                If InStr(strCurrItem, strStringToFind) > 0 Then GoTo Finalize
                End If
        
        If lstListName.ColumnHeaders.Count > 1 Then
            For lngIndexSub = 1 To lstListName.ColumnHeaders.Count - 1
                If bolCaseSensitive = True Then
                    strCurrItem = UCase(lstListName.ListItems.Item(lngIndex).SubItems(lngIndexSub))
                Else
                    strCurrItem = lstListName.ListItems.Item(lngIndex).SubItems(lngIndexSub)
                End If
                
                If bolWholeWordOnly = True Then
                    If strCurrItem = strStringToFind Then GoTo Finalize
                Else
                    If InStr(strCurrItem, strStringToFind) > 0 Then GoTo Finalize
                End If
            Next lngIndexSub
        
        End If
    Next lngIndex
    Exit Function
Finalize:
    EnhListView_Find = lngIndex                             ' send back the index of the found item
    
End Function
Public Function RemoveString(Entire As String, Word As String, Replace As String) As String
    Dim i As Integer
    i = 1
    Dim LeftPart
    Do While True
        i = InStr(1, Entire, Word)
        If i = 0 Then
            Exit Do
        Else
            LeftPart = Left(Entire, i - 1)
            Entire = LeftPart & Replace & Right(Entire, Len(Entire) - Len(Word) - Len(LeftPart))
        End If
    Loop
    
   RemoveString = Entire
End Function
Public Function FormatCount(Count As Long, Optional FormatType As TimeFormatType = 4) As String
    Dim Days As Long, Hours As Long, Minutes As Long, Seconds As Long, Miliseconds As Long
    
    Miliseconds = Count Mod 1000
    Count = Count \ 1000
    Days = Count \ (24& * 3600&)
    If Days > 0 Then Count = Count - (24& * 3600& * Days)
    Hours = Count \ 3600&
    If Hours > 0 Then Count = Count - (3600& * Hours)
    Minutes = Count \ 60
    Seconds = Count Mod 60


    Select Case FormatType
            Case 0
                FormatCount = Days & " days, " & Hours & " hours, " & _
                Minutes & " minutes, " & Seconds & " seconds, " & Miliseconds & _
                " milliseconds"
            Case 1
                FormatCount = Days & " days, " & Hours & " hours, " & _
                Minutes & " minutes, " & Seconds & " seconds"
            Case 2
                FormatCount = Days & ":" & Hours & ":" & _
                Minutes & ":" & Seconds & ":" & Miliseconds
            Case 3
                Select Case Minutes
                    Case "0"
                    Case "1"
                        FormatCount = Minutes & " minute"
                    Case Else
                        FormatCount = Minutes & " minutes"
                End Select
                Select Case Hours
                    Case "0"
                    Case "1"
                        FormatCount = Hours & " hour and " & Minutes & " minutes"
                    Case Else
                        FormatCount = Hours & " hours and " & Minutes & " minutes"
                End Select
                Select Case Days
                    Case "0"
                    Case "1"
                        FormatCount = Days & " day, " & Hours & " hours and " & Minutes & " minutes"
                    Case Else
                        FormatCount = Days & " days, " & Hours & " hours and " & Minutes & " minutes"
                End Select

            Case 4
                Select Case Seconds
                    Case "0"
                        FormatCount = "birth"
                    Case Else
                        FormatCount = Seconds & " seconds"
                End Select
                Select Case Minutes
                    Case "0"
                    Case "1"
                        FormatCount = Minutes & " minute, " & Seconds & " seconds"
                    Case Else
                        FormatCount = Minutes & " minutes, " & Seconds & " seconds"
                End Select
                Select Case Hours
                    Case "0"
                    Case "1"
                        FormatCount = Hours & " hour, " & Minutes & " minutes, " & Seconds & " seconds"
                    Case Else
                        FormatCount = Hours & " hours, " & Minutes & " minutes, " & Seconds & " seconds"
                End Select
                Select Case Days
                    Case "0"
                    Case "1"
                        FormatCount = Days & " day, " & Hours & " hours, " & Minutes & " minutes, " & Seconds & " seconds"
                    Case Else
                        FormatCount = Days & " days, " & Hours & " hours, " & Minutes & " minutes, " & Seconds & " seconds"
            End Select
    End Select
End Function
Public Function CountTalks()
    varTalksTicks = varTalksTicks + 1
    If varTalksTicks >= 30 Then
        Send varIdleMessage, frmMain.WSbnet
        varTalksTicks = 0
    ElseIf varTalksTicks < 30 Then
    ElseIf varTalksTicks > 30 Then
        varTalksTicks = 0
    Else
    End If
End Function
Public Function Matches(ByVal uName As String, ByVal Check As String) As Boolean
    Call PrepareCheck(Check)
    If LCase(uName) Like LCase(Check) Then: Matches = True
End Function
Public Sub PrepareCheck(ByRef tocheck As String)
    tocheck = Replace(tocheck, "[", "")
    tocheck = Replace(tocheck, "]", "")
    tocheck = Replace(tocheck, "", "[[]")
    tocheck = Replace(tocheck, "", "[]]")
    tocheck = Replace(tocheck, "#", "[#]")
    tocheck = Replace(tocheck, "-", "[-]")
End Sub
Public Function ParseProfile(Data As String)
On Error Resume Next
Dim X As Integer
Dim ProfileEnd As String
Dim SplitProfile() As String
Dim splta() As String, splts() As String, spltl() As String, spltd() As String
     ProfileEnd = Mid(Data, 17, Len(Data))
     If ProfileEnd = "" Then Exit Function
     
     SplitProfile = Split(ProfileEnd, Chr(0))
    
     frmProfile.Caption = varProfileChecked & "'s profile..."
     frmProfile.lblName.Caption = varProfileChecked
     frmProfile.txtSex.text = SplitProfile(0)
     frmProfile.txtAge.text = SplitProfile(1)
     frmProfile.txtLocation.text = SplitProfile(2)
     rtbAddDescription SplitProfile(3), vbBage
     frmProfile.Show
End Function
Public Function CheckAutoConnect()
    If varAutoBnet = "yes" Then
        Connect varServer
    Else
    End If
End Function
Public Function LoadFilters()
    ReDim Filters(0)
    Open App.Path & "\libraries\Filters.txt" For Append As #1
        Close #1
    Open App.Path & "\libraries\Filters.txt" For Input As #1
        Do Until EOF(1)
            Line Input #1, Item
                AddFilter Item
            Loop
        Close #1
End Function
Public Function AddFilter(ByVal filter As String)
    If Filters(0) = "" Then
        Filters(0) = filter
    Else
        ReDim Preserve Filters(0 To UBound(Filters) + 1)
        Filters(UBound(Filters)) = filter
    End If
End Function
Public Function GetIPFromHostName(ByVal sHostName As String) As String
   Dim nbytes As Long
   Dim ptrHosent As Long
   Dim ptrName As Long
   Dim ptrAddress As Long
   Dim ptrIPAddress As Long
   Dim sAddress As String
   
   sAddress = Space$(4)

    DoEvents
   ptrHosent = gethostbyname(sHostName & vbNullChar)

   If ptrHosent <> 0 Then
      ptrAddress = ptrHosent + 12
    
      CopyMemory ptrAddress, ByVal ptrAddress, 4
      CopyMemory ptrIPAddress, ByVal ptrAddress, 4
      CopyMemory ByVal sAddress, ByVal ptrIPAddress, 4

      GetIPFromHostName = IPToText(sAddress)

   End If
   
End Function
Private Function IPToText(ByVal IPAddress As String) As String

   IPToText = CStr(Asc(IPAddress)) & "." & _
              CStr(Asc(Mid$(IPAddress, 2, 1))) & "." & _
              CStr(Asc(Mid$(IPAddress, 3, 1))) & "." & _
              CStr(Asc(Mid$(IPAddress, 4, 1)))
              
End Function
Public Function GetHostNameFromIP(ByVal sAddress As String) As String

   Dim ptrHosent As Long
   Dim hAddress As Long
   Dim nbytes As Long
   
   DoEvents
   If 1 = 1 Then

     'convert string address to long
      hAddress = inet_addr(sAddress)
      
      If hAddress <> SOCKET_ERROR Then
         ptrHosent = gethostbyaddr(hAddress, 4, AF_INET)
   
         If ptrHosent <> 0 Then
            CopyMemory ptrHosent, ByVal ptrHosent, 4
            nbytes = lstrlen(ByVal ptrHosent)
         
            If nbytes > 0 Then
               sAddress = Space$(nbytes)
               CopyMemory ByVal sAddress, ByVal ptrHosent, nbytes
               GetHostNameFromIP = sAddress
            End If
         
         Else: rtbAdd "Call to gethostbyaddr failed." & vbNewLine, vbBage
         End If 'If ptrHosent
      
      Else: rtbAdd "String passed is an invalid IP." & vbNewLine, vbBage
      End If 'If hAddress
   
   Else: rtbAdd "Sockets failed to initialize." & vbNewLine, vbBage
   End If  'If SocketsInitialize
      
End Function

