VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RecvBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Function GetNTString(Data As String, start As Integer) As String
    GetNTString = Mid(Data, start, InStr(start, Data, Chr(0)))
    GetNTString = Left(GetNTString, InStr(GetNTString, Chr(0)) - 1)
End Function

Private Function GetDwordCVL(Data As String, start As Integer) As Long
    GetDwordCVL = CVL(Mid(Data, start, 4))
End Function

Private Function GetWordCVI(Data As String, start As Integer) As Integer
    GetWordCVL = CVI(Mid(Data, start, 2))
End Function

Private Function Extract(t As VbVarType, strData As String, start As Integer)
    Select Case t
        Case vbLong
            Extract = CVL(Mid(strData, start, 4))
        Case vbString
            Extract = Mid(strData, start, InStr(start, strData, Chr(0)) - start)
        Case vbInteger
            Extract = CVI(Mid(strData, start, 2))
        Case Else
            Err.Raise 3, "Extract", "No definition for VarType " & t
    End Select
End Function

Public Sub OnRecieve(Data As String, Socket As Winsock)
    Dim packet As New PacketBuffer
    
    If Len(Data) = 0 Then Exit Sub
    If Not Mid(Data, 1, 1) = Chr(&HFF) Then Exit Sub
    
    Select Case Asc(Mid$(Data, 2, 1))
        Case &H25
            If varLagPlug = "yes" Then
            Else
                Dim socket2 As New PacketBuffer
                socket2.InsertNonNTString Mid(Data, 5, 4)
                socket2.SendPacket frmMain.WSbnet, &H25
            End If
        Case &H50
            Dim sessionid As String
            Dim hash As String
            Dim MPQName As String
            servers = Val("&h" & StrToHex(StrReverse(Mid(Data, 9, 4))))
            sessionid = Mid(Data, 2 * 4, 4)
            hash = Mid(Data, 38, Len(Data) - 2)
            MPQName = Mid(Data, InStr(1, Data, "IX86ver"), Len(Data))
            MPQName = Mid(MPQName, 1, 12)
            Packet0x51 hash, MPQName, CVL(sessionid)
        Case &H51
            Dim Result As Long
            Result = GetDWORD(Mid(Data, 4, 4))
            If Result = &H0 Then
                rtbAdd "Versions and cdkey accepted." & vbNewLine, vbGrey
                If varAccountManager = "yes" Then
                    frmAccountManager.Show
                    Exit Sub
                Else
                    ContinueConnect
                End If
            ElseIf Result = 65792 Then
                rtbAdd "Version was rejected by Battle.net." & vbNewLine, vbGrey
            ElseIf Result = 131072 Then
                rtbAdd "CDKey was rejected by Battle.net." & vbNewLine, vbGrey
            Else
                rtbAdd "Version or CDKey was rejected by Battle.net." & vbNewLine, vbRed
            End If
        Case &H2D
            Dim Splits() As String
                Splits = Split(Mid(Data, 1, Len(Data) - 1), Chr(1), 2)
            Erase Splits()
        Case &H3D
            Select Case Asc(Mid(Data, 5, 1))
                Case &H0
                    rtbAdd "Account created!" & vbNewLine, vbGreen
                    ContinueConnect
                Case &H1
                    rtbAdd "Account create failed: name too short!" & vbNewLine, vbRed
                    frmMain.WSbnet.Close
                Case &H2
                    rtbAdd "Account create failed: invalid characters!" & vbNewLine, vbRed
                    frmMain.WSbnet.Close
                Case &H3
                    rtbAdd "Account create failed: bad words, you bad boy!" & vbNewLine, vbRed
                    frmMain.WSbnet.Close
                Case &H4
                    rtbAdd "Account create failed: account exists!" & vbNewLine, vbRed
                    frmMain.WSbnet.Close
                Case Else
                    rtbAdd "Account create failed: failed!" & vbNewLine, vbRed
                    frmMain.WSbnet.Close
            End Select
        Case &H3A
            Select Case Asc(Mid(Data, 5, 1))
                Case &H0
                    rtbAdd "Battle.net login accepted." & vbNewLine, vbGrey
                    ContinueBnet
                Case Else
                    rtbAdd "Battle.net login failed." & vbNewLine, vbRed
                    SendCreateAccount varUsername, varPassword
            End Select
        Case &H34
                frmRealmCharSel.Show
        Case &H3E
            Dim Server As String
            Dim bleh2 As String
            Dim port As String
                p1 = Mid(Data, 5, 16)
                Server = Mid(Data, 17, 8)
                bleh2 = Mid(Server, 5, 4)
                    rtbAdd "Attempting to connect to MCP server " & makeserver(bleh2) & vbNewLine, vbGrey
                p2 = Mid(Data, 29, 48)
                urname = Mid(Data, 77, Len(Data) - 79)
                frmMain.WSmcp.Close
                frmMain.WSmcp.Connect makeserver(bleh2), 6112
        Case &HB
            Dim Split0B() As String
                Split0B() = Split(Mid(Data, 5, Len(Data)), Chr(0))
                    frmChannels.lstChannels.ListItems.Clear
                    For i = 0 To UBound(Split0B) - 2
                        frmChannels.lstChannels.ListItems.Add , , Split0B(i)
                    Next i
                Erase Split0B()
            Exit Sub
        Case &HA
            Dim spltn() As String
            Dim strss As String
            spltn() = Split(Data, Chr(0), 5)
            ParseStatString spltn(2), strss
            
            rtbAdd "Logged on as " & spltn(1) & vbNewLine, vbGrey
            MyName = spltn(1)
        Case &HF
            ParseBinary Data
        Case &H0
            pBuffer.SendPacket frmMain.WSbnet, &H0
        Case &H46
            Dim tmpnews As Long
            Dim spltns() As String
                spltns() = Split(StrToHex(Mid(Data, 22)), "0A")
                For tmpnews = 0 To UBound(spltns) - 1
                    rtbAdd "News: " & HexToStr(spltns(tmpnews)) & vbNewLine, vbYellow
                Next tmpnews
            Exit Sub
            Erase spltns()
        Case &H26
            ParseProfile Data
        Case Else
            rtbAdd "Unidentified Packet(hex): ", vbGrey, StrToHex(Data) & vbNewLine, vbRed
    End Select
End Sub
